#include <motelib/system.h>
#include <motelib/led.h>
#include <motelib/timer.h>
#include <motelib/sensor.h>
#include <motelib/radio.h>
#include <motelib/actor.h>
#include "platform.h"
#include <motelib/uart.h>
#include <motelib/button.h>
Timer t1;
typedef struct Send {
  uint16_t value;
  uint16_t ID;
}dataSend;
uint8_t state = 0; 
#define ntohs(x) (((x&0xff00)>>8) | ((x&0x00ff)<<8)) // receive
#define htons(x) (((x&0xff00)>>8) | ((x&0x00ff)<<8)) // send

void dataReady(uint16_t value)
{
  // value stores sensor reading
	// printf("%d\n", value);

	dataSend data;
	data.value =  htons(value);
	data.ID = htons(getAddress());

	radioRequestTx(BROADCAST_ADDR, 150, &data,sizeof(data), NULL);
}


void receive(Address src, MessageType type, void *msg, uint8_t len)
{
    if (type == 150)
    {
        uint16_t value = ntohs(((uint16_t*)msg)[0]);
        uint16_t ID = ntohs(((uint16_t*)msg)[1]);
        printf("%d\n",value);
    }
}

void senseLight(Timer *t)
{
	// sensor 2 temp
	// sensor 1 light
	sensorRequestAnalog(SENSOR_1, dataReady);
}

void button(ButtonStatus s)
{
    // Toggle LED#1 whenever the button is pressed
  if (s == BUTTON_PRESSED)
  {
        if(state == 0)
          ledSetValue(0);
    else if(state==1)
      ledSetValue(4);
    else if(state == 2)
      ledSetValue(2);
    else if(state == 3)
      ledSetValue(1);

  dataSend data;
  data.value =  htons(1);
  data.ID = htons(getAddress());

  radioRequestTx(0, 150, &data,sizeof(data), NULL);
    state = state+1;
    state = state%4;
  } 
}

void boot()
{
	uartEnable(true,true);
	radioSetRxHandler(receive);
	actorSetState(ACTOR_0,1);
  if (getAddress()==1)
  {
    buttonSetHandler(button);
  }
  else if(getAddress() == 2)
  {
    timerCreate(&t1);
    timerStart(&t1, TIMER_PERIODIC, 250, senseLight);
  }
    
}
